grub-devel
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH v3] templates: Output a menu entry for firmware setup on UEFI Fas


From: Javier Martinez Canillas
Subject: [PATCH v3] templates: Output a menu entry for firmware setup on UEFI FastBoot systems
Date: Wed, 15 Apr 2020 12:32:17 +0200

From: Steve Langasek <address@hidden>

The fwsetup command allows to reboot into the EFI firmware setup menu, add
a template to include a menu entry on EFI systems that makes use of that
command to reboot into the EFI firmware settings.

This is useful for users since the hotkey to enter into the EFI setup menu
may not be the same on all systems so users can use the menu entry without
needing to figure out what key needs to be pressed.

Also, if fastboot is enabled in the BIOS then often it is not possible to
enter the firmware setup menu. So the entry is again useful for this case.

Signed-off-by: Steve Langasek <address@hidden>
Signed-off-by: Dimitri John Ledkov <address@hidden>
Signed-off-by: Hans de Goede <address@hidden>
Signed-off-by: Javier Martinez Canillas <address@hidden>
Reviewed-by: Daniel Kiper <address@hidden>
---

Changes in v3:
- Fix date in copyright notice.

Changes in v2:
- Improve commit message.
- Squash latest changes from the Ubuntu branch.
- Address issues pointed out by Daniel Kiper in v1.
Patch-cc: Daniel Kiper <address@hidden>

 Makefile.util.def               |  6 +++++
 util/grub.d/30_uefi-firmware.in | 44 +++++++++++++++++++++++++++++++++
 2 files changed, 50 insertions(+)
 create mode 100644 util/grub.d/30_uefi-firmware.in

diff --git a/Makefile.util.def b/Makefile.util.def
index 1e0799a68f9..d9e2bd84de8 100644
--- a/Makefile.util.def
+++ b/Makefile.util.def
@@ -515,6 +515,12 @@ script = {
   installdir = grubconf;
 };
 
+script = {
+  name = '30_uefi-firmware';
+  common = util/grub.d/30_uefi-firmware.in;
+  installdir = grubconf;
+};
+
 script = {
   name = '40_custom';
   common = util/grub.d/40_custom.in;
diff --git a/util/grub.d/30_uefi-firmware.in b/util/grub.d/30_uefi-firmware.in
new file mode 100644
index 00000000000..d344d3883d7
--- /dev/null
+++ b/util/grub.d/30_uefi-firmware.in
@@ -0,0 +1,44 @@
+#! /bin/sh
+set -e
+
+# grub-mkconfig helper script.
+# Copyright (C) 2020  Free Software Foundation, Inc.
+#
+# GRUB is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# GRUB is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+
+prefix="@prefix@"
+exec_prefix="@exec_prefix@"
+datarootdir="@datarootdir@"
+
+export TEXTDOMAIN=@PACKAGE@
+export TEXTDOMAINDIR="@localedir@"
+
+. "$pkgdatadir/grub-mkconfig_lib"
+
+EFI_VARS_DIR=/sys/firmware/efi/efivars
+EFI_GLOBAL_VARIABLE=8be4df61-93ca-11d2-aa0d-00e098032b8c
+OS_INDICATIONS="$EFI_VARS_DIR/OsIndicationsSupported-$EFI_GLOBAL_VARIABLE"
+
+if [ -e "$OS_INDICATIONS" ] && \
+   [ "$(( $(printf 0x%x \'"$(cat $OS_INDICATIONS | cut -b5)"\') & 1 ))" = 1 ]; 
then
+  LABEL="UEFI Firmware Settings"
+
+  gettext_printf "Adding boot menu entry for UEFI Firmware Settings ...\n" >&2
+
+  cat << EOF
+menuentry '$LABEL' \$menuentry_id_option 'uefi-firmware' {
+       fwsetup
+}
+EOF
+fi
-- 
2.25.1




reply via email to

[Prev in Thread] Current Thread [Next in Thread]